/* -*- mode: c++ -*-
  CPP_CONTEST=2012-CUDA
  CPP_PROBLEM=A
  CPP_LANG=CUDA1+OPENMP
*/

#include <stdlib.h>
#include <omp.h>
#include <cutil_inline.h>


void Image_Smoothing_by_Filtering(unsigned char *Imagen, unsigned int Size, int Rep)
{
  int
     k;

  unsigned int
     stride, i, j, auxi;

  unsigned char
     *tImage=NULL,
     *aImage=NULL;

  /* Vectores para almacenamiento temporal */
  tImage = (unsigned char *)calloc(Size+2, sizeof(unsigned char));
  aImage = (unsigned char *)calloc(Size+2, sizeof(unsigned char));

  stride = Size+2;

  for (k=1; k<=Rep; k++)
  {
     memcpy(tImage, Imagen, stride);
     for(i=1; i<=Size; i++)
     {
        memcpy(aImage, tImage,            stride);
        memcpy(tImage, &Imagen[i*stride], stride);

        for(j=1; j<=Size; j++)
        {
           auxi = (i+1)*stride + j;

           Imagen[i*stride+j]=(aImage[j-1]    + aImage[j]    + aImage[j+1] +
                               tImage[j-1]    + tImage[j]    + tImage[j+1] +
                               Imagen[auxi-1] + Imagen[auxi] + Imagen[auxi+1]) / 9;
        }
     }
  }
  free(tImage);
  free(aImage);
}
